VERSION 5.00
Begin VB.Form Tiled 
   BorderStyle     =   5  'Sizable ToolWindow
   Caption         =   "Tiled View"
   ClientHeight    =   2865
   ClientLeft      =   60
   ClientTop       =   300
   ClientWidth     =   2880
   Icon            =   "TiledForm.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   2865
   ScaleWidth      =   2880
   ShowInTaskbar   =   0   'False
   StartUpPosition =   3  'Windows Default
   Begin VB.Timer Timer1 
      Interval        =   5
      Left            =   360
      Top             =   240
   End
End
Attribute VB_Name = "Tiled"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Dim ShouldUpdate As Long
Dim ViewScale As Integer
Dim CurrentFrame As Integer
Dim Animate As Integer
Dim FrameCountdown As Integer
Dim LastTickCount As Long
Sub EnableAnimation(ByVal Enable As Integer)
  Animate = Enable
  If Enable Then
    CurrentFrame = 0
    FrameCountdown = Main.GetFrameDuration(0)
  End If
  Update
End Sub

Sub Update()
  Main.DrawTiledPixels Me, ViewScale, CurrentFrame
End Sub

Private Sub Form_KeyDown(KeyCode As Integer, Shift As Integer)
  If KeyCode = 107 Or KeyCode = 187 Then
    ViewScale = ViewScale + 1
    Update
  End If
  If KeyCode = 109 Or KeyCode = 189 Then
    If ViewScale > 1 Then
      ViewScale = ViewScale - 1
      Update
    End If
  End If
  If KeyCode = 36 Then
    ViewScale = 1
    Update
  End If
End Sub

Private Sub Form_Load()
  ViewScale = 4
  LastTickCount = GetTickCount
End Sub

Private Sub Form_MouseDown(Button As Integer, Shift As Integer, x As Single, y As Single)
  If Button = 1 Then
    ViewScale = ViewScale + 1
    Update
  End If
  If Button = 2 Then
    If ViewScale > 1 Then ViewScale = ViewScale - 1
    Update
  End If
End Sub


Private Sub Form_Paint()
  Update
End Sub

Private Sub Form_Unload(Cancel As Integer)
  Main.mViewAnimate.Checked = False
End Sub

Private Sub Timer1_Timer()
  If Visible And Main.FrameCount > 1 And Animate Then
    Dim CurrentTickCount As Long
    CurrentTickCount = GetTickCount
    While CurrentTickCount - LastTickCount > 10
      FrameCountdown = FrameCountdown - 1
      If FrameCountdown <= 0 Then
        CurrentFrame = (CurrentFrame + 1) Mod Main.FrameCount()
        FrameCountdown = Main.GetFrameDuration(CurrentFrame)
      End If
      LastTickCount = LastTickCount + 10
    Wend
    Update
  End If
End Sub
